"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sortObjectArrByProps = void 0;
function sortObjectArrByProps(objArr, objProps, reverse = 's') {
    let sortedObjectArray = [];
    let values = [];
    let indices = [];
    let missingProps = false;
    if (!!Array.isArray(objProps)) {
        for (let i = 0; i < objArr.length; i++) {
            values.push([]);
            indices.push(i);
        }
        for (let j = 0; j < objArr.length; j++) {
            for (let k = 0; k < objProps.length; k++) {
                if (objArr[j].hasOwnProperty(objProps[k])) {
                    values[j].push(objArr[j][objProps[k]]);
                }
                else {
                    values[j].push('⭢');
                    missingProps = true;
                }
            }
        }
    }
    else {
        objArr.forEach((obj, i) => {
            if (obj.hasOwnProperty(objProps)) {
                typeof objProps === 'string'
                    || typeof objProps === 'number'
                    ? values.push(obj[objProps])
                    : values.push(obj[objProps].toString());
            }
            else {
                values.push('⭢');
                missingProps = true;
            }
            indices.push(i);
        });
    }
    if (!!Array.isArray(objProps)) {
        let k = 0;
        for (let i = 1; i < values.length; i++) {
            for (let j = 0; j < values.length - i;) {
                if (!missingProps) {
                    if (values[j][k] === values[j + 1][k]) {
                        if (k === objProps.length - 1) {
                            k = 0;
                            j++;
                        }
                        else {
                            k++;
                        }
                    }
                    else if (values[j][k] > values[j + 1][k]) {
                        [values[j], values[j + 1]] = [values[j + 1], values[j]];
                        [indices[j], indices[j + 1]] = [indices[j + 1], indices[j]];
                        k = 0;
                        j++;
                    }
                    else {
                        k = 0;
                        j++;
                    }
                }
                else {
                    if (values[j][k].toString() === values[j + 1][k].toString()) {
                        if (k === objProps.length - 1) {
                            k = 0;
                            j++;
                        }
                        else {
                            k++;
                        }
                    }
                    else if (values[j][k].toString() > values[j + 1][k].toString()) {
                        [values[j], values[j + 1]] = [values[j + 1], values[j]];
                        [indices[j], indices[j + 1]] = [indices[j + 1], indices[j]];
                        k = 0;
                        j++;
                    }
                    else {
                        k = 0;
                        j++;
                    }
                }
            }
        }
    }
    else {
        for (let i = 1; i < values.length; i++) {
            for (let j = 0; j < values.length - i; j++) {
                if (!missingProps) {
                    if (values[j] > values[j + 1]) {
                        [values[j], values[j + 1]] = [values[j + 1], values[j]];
                        [indices[j], indices[j + 1]] = [indices[j + 1], indices[j]];
                    }
                }
                else {
                    if (values[j].toString() > values[j + 1].toString()) {
                        [values[j], values[j + 1]] = [values[j + 1], values[j]];
                        [indices[j], indices[j + 1]] = [indices[j + 1], indices[j]];
                    }
                }
            }
        }
    }
    for (let i of indices) {
        sortedObjectArray.push(objArr[i]);
    }
    reverse === 'r'.toLowerCase() && sortedObjectArray.reverse();
    return sortedObjectArray;
}
exports.sortObjectArrByProps = sortObjectArrByProps;
